#ifndef NOISETEXTURE_H
#define NOISETEXTURE_H

#include <GL/glew.h>
#include <GLFW/glfw3.h>

#include "common/utils/Types.h"

class NoiseTexture final
{
public:
    NoiseTexture(u32 width, u32 height);
    ~NoiseTexture();
    
    NoiseTexture(const NoiseTexture& other) = delete;
    NoiseTexture(NoiseTexture&& other) = delete;
    NoiseTexture& operator=(const NoiseTexture& other) = delete;
    NoiseTexture& operator=(NoiseTexture&& other) = delete;
    
    void bind(unsigned int index) const;
    
private:
    float getRandom() const;
    
    u32 width;
    u32 height;
    
    GLuint texture = 0;
};

#endif

