#ifndef SERVER_H
#define SERVER_H

#include "common/utils/Types.h"
#include "common/stream/Stream.h"

namespace Server
{
    typedef void (*FullServerClientConnectFunction) (int);
    typedef void (*ClientConnectFunction) (int);
    typedef void (*ClientPackageFunction) (int, Stream&);
    typedef void (*ClientDisconnectFunction) (int);
    
    bool start(u16 port, u16 maxClients);
    void setFullServerClientConnectFunction(FullServerClientConnectFunction f);
    void setClientConnectFunction(ClientConnectFunction f);
    void setClientPackageFunction(ClientPackageFunction f);
    void setClientDisconnectFunction(ClientDisconnectFunction f);
}

#endif